package ch.loosli.protrading.equitySearcher;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import ch.loosli.protrading.signalLoader.Signal;

public class EquitySearcherConfig extends JPanel{

	private static EquitySearcherConfig instance;
	private EquitySearcherController esc = new EquitySearcherController();
	
	
	private static final long	serialVersionUID	= 3557546389681504191L;

	private GridBagConstraints gbc = new GridBagConstraints();
	
	
	// Components
	private JComboBox<Signal> signal;
	private JSlider minRate;
	private JLabel minLabel;
	private JSlider maxRate;
	private JLabel maxLabel;
	private JButton search;
	
	
	
	public EquitySearcherConfig() {
		this.setLayout(new GridBagLayout());
		this.setVisible(true);
	}
	
	
	public void display() {
		gbc.insets = new Insets(5,5,5,5);
		gbc.gridx = 0;
		gbc.gridy = 0;
		
		signal = new JComboBox<Signal>(new Signal[] {Signal.BUY, Signal.SELL, Signal.HOLD});
		signal.setSize(new Dimension(100, 20));
		signal.setVisible(true);
		this.add(signal, gbc);
		
		gbc.gridx = 0;
		gbc.gridy = 1;
		
		search = new JButton("Search");
		search.setSize(100, 20);
		search.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				esc.updateResults((Signal)signal.getSelectedItem(), minRate.getValue(), maxRate.getValue());
			}
		});
		search.setVisible(true);
		this.add(search, gbc);
		
		gbc.gridx = 1;
		gbc.gridy = 0;
		
		minRate = new JSlider(JSlider.HORIZONTAL, 0, 1000, 50);
		minRate.setMajorTickSpacing(100);
		minRate.setMinorTickSpacing(10);
		minRate.addChangeListener(new ChangeListener() {

			@Override
			public void stateChanged(ChangeEvent e) {
				minLabel.setText(minRate.getValue() + "");
				Mainframe.getInstance().pack();
			}
			
		});
		minRate.setVisible(true);
		this.add(minRate, gbc);
		
		gbc.gridx = 1;
		gbc.gridy = 1;
		
		maxRate = new JSlider(JSlider.HORIZONTAL, 0, 1000, 50);
		maxRate.setMajorTickSpacing(100);
		maxRate.setMinorTickSpacing(10);
		maxRate.addChangeListener(new ChangeListener() {

			@Override
			public void stateChanged(ChangeEvent e) {
				maxLabel.setText(maxRate.getValue() + "");
				Mainframe.getInstance().pack();
			}
			
		});
		maxRate.setVisible(true);
		this.add(maxRate, gbc);
		
		gbc.gridx = 2;
		gbc.gridy = 0;
		
		minLabel = new JLabel(minRate.getValue() + "");
		minLabel.setSize(50, 20);
		minLabel.setVisible(true);
		this.add(minLabel, gbc);
		
		gbc.gridx = 2;
		gbc.gridy = 1;
		
		maxLabel = new JLabel(maxRate.getValue() + "");
		maxLabel.setSize(50,20);
		maxLabel.setVisible(true);
		this.add(maxLabel, gbc);
	}
	
	
	
	
	public static EquitySearcherConfig getInstance() {
		if(instance == null) {
			instance = new EquitySearcherConfig();
		}
		return instance;
	}
}
