package ch.loosli.protrading.equitySearcher;

import java.util.ArrayList;

import ch.loosli.protrading.signalLoader.Equity;
import ch.loosli.protrading.signalLoader.QuoteLoader;
import ch.loosli.protrading.signalLoader.Signal;

public class EquitySearcherController {

	private EquitySearcherResultPane esrp = new EquitySearcherResultPane();
	
	
	public void updateResults(Signal signal, double minimum, double maximum) {
		esrp.updateTable(this.getEquitiesBySignalAndRate(signal, minimum, maximum));
	}
	
	
	private ArrayList<Equity> getEquitiesBySignalAndRate(Signal signal, double minimum, double maximum) {
		Thread t1 = new Thread(new QuoteLoader());
		Thread t2 = new Thread(new QuoteLoader());
		Thread t3 = new Thread(new QuoteLoader());
		Thread t4 = new Thread(new QuoteLoader());
		
		t1.start();
		t2.start();
		t3.start();
		t4.start();
		
		
		while(t1.isAlive() || t2.isAlive() || t3.isAlive() || t4.isAlive()) {
			
		}
		
		ArrayList<Equity> selected = QuoteLoader.getQuoteList();
		
		for(int i = 0; i < selected.size(); i++) {
			Equity e = selected.get(i);
			if(e.getSignal() != signal || e.getLastRate() > maximum || e.getLastRate() < minimum) {
				selected.remove(i);
				i--;
			}				
			
		}
		
		return selected;
	}
}
