package ch.loosli.protrading.equitySearcher;

import java.util.ArrayList;

import javax.swing.JScrollPane;
import javax.swing.JTable;

import ch.loosli.protrading.signalLoader.Equity;

@SuppressWarnings("serial")
public class EquitySearcherResultPane extends JScrollPane{

	private static EquitySearcherResultPane instance;
	
	private String[] headers = {"Equity", "Rate"};
	
	ResultTableModel rtm = new ResultTableModel();
	JTable resultTable;
	
	
	public EquitySearcherResultPane() {
		for(String s : headers) {
			rtm.addColumn(s);
		}
		resultTable = new JTable(rtm);		
	}
	
	
	
	public void display() {
		resultTable.setVisible(true);
		resultTable.setVisible(true);
		this.add(resultTable);
		this.setVisible(true);
	}
	
	
	
	public Object[][] updateTable(ArrayList<Equity> list) {
		Object[][] data = new Object[list.size()][2];
		for(int i = 0; i < list.size(); i++) {
			Equity e = list.get(i);
			data[i][0] = e.getTicker();
			data[i][1] = e.getLastRate();
			rtm.addRow(data[i]);
		}
		rtm.setDataVector(data, headers);
		resultTable.repaint();
		
		return data;
		
	}
	
	
	public static EquitySearcherResultPane getInstance() {
		if(instance == null) {
			instance = new EquitySearcherResultPane();
		}
		return instance;
	}
}
