package ch.loosli.protrading.signalLoader;

import java.time.LocalDate;


/**
 * 
 * @author Roman Loosli
 * @version 1.0
 * @since Version 1.0
 *
 */
public class DayRecord {

	private LocalDate	date;
	private double		open;
	private double		high;
	private double		low;
	private double		close;
	private long		volume;
	private double		adjustedClosePrice;
	
	
	public DayRecord(LocalDate date, double open, double high, double low, double close, long volume, double adjustedClosePrice) {
		this.date = date;
		this.open = open;
		this.high = high;
		this.low = low;
		this.close = close;
		this.volume = volume;
		this.adjustedClosePrice = adjustedClosePrice;
	}


	/**
	 * @return the date
	 */
	public LocalDate getDate() {
		return date;
	}
	

	/**
	 * @return the open
	 */
	public double getOpen() {
		return open;
	}


	/**
	 * @return the high
	 */
	public double getHigh() {
		return high;
	}


	/**
	 * @return the low
	 */
	public double getLow() {
		return low;
	}


	/**
	 * @return the close
	 */
	public double getClose() {
		return close;
	}


	/**
	 * @return the volume
	 */
	public long getVolume() {
		return volume;
	}


	/**
	 * @return the adjustedClosePrice
	 */
	public double getAdjustedClosePrice() {
		return adjustedClosePrice;
	}
}
