package ch.loosli.protrading.signalLoader;

import java.util.ArrayList;
import java.util.Date;
import java.util.Properties;

import javax.mail.Message;
import javax.mail.MessagingException;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;


public class Main {

	
	public static Date lastSentEmailDate;
	
	@SuppressWarnings("deprecation")
	public static void main(String[] args) {		
		while(true) {
			
			if((lastSentEmailDate == null || lastSentEmailDate.getDate() != new Date().getDate()) && new Date().getHours() > 11) {
				System.out.println("Executing!\t" + new Date().toString());
				
				
				String buyMessage = "Acutal Buy-Signals: \n\n";
				String sellMessage = "Acutal Sell-Signals: \n\n";
				String holdMessage = "Acutal Hold-Signals: \n\n";
				
				QuoteLoader ql = new QuoteLoader();
				ArrayList<Equity> list = ql.searchThroughAllQuotes();
			
				for(Equity e : list) {				
					if(e.getSignal() == Signal.BUY) {
						buyMessage += e.getTicker() + ", " + e.getLastRate() + "\n";
					}
					else if(e.getSignal() == Signal.SELL) {
						sellMessage += e.getTicker() + ", " + e.getLastRate() + "\n";
					}
					else if(e.getSignal() == Signal.HOLD) {
						holdMessage += e.getTicker() + ", " + e.getLastRate() + "\n";
					}	
							
					
				}
				try {
					sendMail(buyMessage, "BUY-Signals");
					sendMail(sellMessage, "SELL-Signals");
					sendMail(holdMessage, "HOLD-Signals");	
					lastSentEmailDate = new Date();
				} catch (MessagingException me) {
					System.out.println("Couldn't send Email | " + lastSentEmailDate.toString());
				}
				
				}
				
				try {
					Thread.sleep(1800000);
				}
				catch (InterruptedException e) {
					e.printStackTrace();
				}
			
		}
	}
	
	
	
	private static void sendMail(String emailMessage, String subject) throws MessagingException {
		String username = "roman.loosli69@gmail.com";
		String password = "aktph97$";
		
		Properties props = System.getProperties();
        String host = "smtp.gmail.com";
        props.put("mail.smtp.starttls.enable", "true");
        props.put("mail.smtp.host", host);
        props.put("mail.smtp.user", username);
        props.put("mail.smtp.password", password);
        props.put("mail.smtp.port", "587");
        props.put("mail.smtp.auth", "true");

        Session session = Session.getDefaultInstance(props);
        MimeMessage message = new MimeMessage(session);

        message.setFrom(new InternetAddress(username));


        message.addRecipient(Message.RecipientType.TO, new InternetAddress("roman@loosli-design.ch"));

        message.setSubject(subject);
        message.setText(emailMessage);
        Transport transport = session.getTransport("smtp");
        transport.connect(host, username, password);
        transport.sendMessage(message, message.getAllRecipients());
        transport.close();
	}
	

}

