package ch.loosli.protrading.signalLoader;

public class SignalChooser {

	
	
	/**
	 * Searches the Signal for a specified Equity.
	 * @param e The Equity the Signal is searched for.
	 * @return The choosen Signal.
	 */
	public static Signal chooseSignal(Equity e) {
		if(shouldBuy(e)) {
			return Signal.BUY;
		}
		else if(shouldSell(e)) {
			return Signal.SELL;
		}
		
		else return Signal.HOLD;
	}
	
	
	
	private static boolean shouldBuy(Equity e) {
		try {
			if(e.getHighestCloseFromPeriod(20, 4) == e.getDayrecords().get(e.getDayrecords().size() - 5).getClose()) {
				if(e.getHighestCloseFromPeriod(20, 4) <= e.getDayrecords().get(e.getDayrecords().size() - 4).getClose()) {
					if(e.getHighestCloseFromPeriod(20, 4) <= e.getDayrecords().get(e.getDayrecords().size() - 3).getClose()) {
						if(e.getHighestCloseFromPeriod(20, 4) <= e.getDayrecords().get(e.getDayrecords().size() - 2).getClose()) {
							if(e.getHighestCloseFromPeriod(20, 4) <= e.getDayrecords().get(e.getDayrecords().size() - 1).getClose()) {
								return true;
							}
						}
					}
				}
			}			
		} catch (IndexOutOfBoundsException ioobe) {
			return false;
		}
		return false;
	}
	
	
	
	private static boolean shouldSell(Equity e) {
		try {
			double tenDayLow = e.getLowestCloseFromPeriod(10, 2);
			if(tenDayLow == e.getDayrecords().get(e.getDayrecords().size() - 3).getClose()) {
				if(tenDayLow >= e.getDayrecords().get(e.getDayrecords().size() - 2).getClose()) {
					if(tenDayLow >= e.getDayrecords().get(e.getDayrecords().size() - 1).getClose()) {
						return true;
					}
				}
			}
			// returning trend
			if(e.getDayrecords().get(e.getDayrecords().size()-1).getClose() / e.getDayrecords().get(e.getDayrecords().size()-2).getClose() < e.getDayrecords().get(e.getDayrecords().size()-2).getClose() / e.getDayrecords().get(e.getDayrecords().size()-3).getClose()) {
				if(e.getDayrecords().get(e.getDayrecords().size()-2).getClose() / e.getDayrecords().get(e.getDayrecords().size()-3).getClose() < e.getDayrecords().get(e.getDayrecords().size()-3).getClose() / e.getDayrecords().get(e.getDayrecords().size()-4).getClose()) {
					if(e.getDayrecords().get(e.getDayrecords().size()-3).getClose() / e.getDayrecords().get(e.getDayrecords().size()-4).getClose() < e.getDayrecords().get(e.getDayrecords().size()-4).getClose() / e.getDayrecords().get(e.getDayrecords().size()-5).getClose()) {
						if(e.getDayrecords().get(e.getDayrecords().size()-4).getClose() / e.getDayrecords().get(e.getDayrecords().size()-5).getClose() < e.getDayrecords().get(e.getDayrecords().size()-5).getClose() / e.getDayrecords().get(e.getDayrecords().size()-6).getClose()) {
							return true;
						}
					}
				}
			}
		} catch (IndexOutOfBoundsException ioobe) {
			return false;
		}
		return false;
	}
	
}
