package ch.loosli.protrading.signalLoader;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

public class TickerFilesParser {

	private static TickerFilesParser instance;
	
	private File sp500File = new File("\\\\192.168.0.52\\privat\\roman\\Work @ Home\\projects\\Pro Trading\\s&p500.csv");
	private long numReadSP500;
	
	
	private TickerFilesParser() {
		numReadSP500 = 0;
	}
	
	
	public long getNumReadSP500() {
		return numReadSP500;
	}
	
	
	
	public String getNextSP500Ticker() {
		String ticker = null;
		try (BufferedReader br = new BufferedReader(new FileReader(this.sp500File))){
			for(int i = 0; i <= this.numReadSP500 % 500; i++) {
				ticker = br.readLine();
			}
		}
		catch (IOException e) {
			e.printStackTrace();
			return null;
		}		
		
		this.numReadSP500++;
		return ticker;
	}
	
	
	
	
	public static TickerFilesParser getInstance() {
		if(instance == null) {
			instance = new TickerFilesParser();
		}
		return instance;
	}
}
